import java.util.*;
import java.net.*;
import logic.*;

class URLProcessor_good extends URLProcessor implements logic.Updateable {

        //constant used for doing update
        static final String URL_STR = "urlString";
        
        URLProcessor_good(){
                super();
        }
        
        void decideUrl() {
                try {
                    Invoker inv = new ConcreteInvoker((Updateable)this);
                    inv.execute();
                }
                catch(NestingTooDeepException ntde) {
                    //handle
                    System.out.println(ntde.getMessage());
                }
                
                catch(IllegalExpressionException iee) {
                    //handle
                    System.out.println(iee.getMessage());
                }
                
                catch(RuleNotFoundException rnfe) {
                    //handle
                    System.out.println(rnfe.getMessage());
                }
                
                catch(DataNotFoundException dnfe) {
                    //handle
                    System.out.println(dnfe.getMessage());
                }
        }
        
        /** Updateable interface implementation */
        public void doUpdate(Hashtable ht) {
                if(ht == null) return;
                Object ob = ht.get(Action.MAIN_KEY);
                if(ob != null && ob instanceof String) {
                    setUrl((String)ob);
                }
        }

        static class OtherCondition extends Condition {
                public static final String KEY = "key";
                public OtherCondition(Hashtable ht) {
                        super(ht);
                }
                public Boolean evaluate() throws DataNotFoundException {
                        Object ob = null;
                        if(getData() == null || (ob = getData().get(KEY)) == null) {
                                throw new DataNotFoundException();
                        }
                        if(!(ob instanceof DataBank.Region)) {
                                return Boolean.FALSE;
                        }
                        DataBank.Region region = (DataBank.Region)ob;
                        boolean result = !region.equals(DataBank.WEST_REGION) &&
                                                         !region.equals(DataBank.EAST_REGION);
                        return new Boolean(result);
                }
                        
                        
        }
        

        static class MemberCondition extends Condition {
            public static final String KEY = "id";
            public static final String TABLE = "table";
            
            /** 
             *  The argument ht should have KEY matched with user id and
             *  TABLE matched with westMember hashtable
             */
            public MemberCondition(Hashtable ht) {
                super(ht);
            }
            public Boolean evaluate() throws DataNotFoundException {
                Object id = null, table = null;
                if(getData() == null || ((id = getData().get(KEY)) == null) || 
                    ((table = getData().get(TABLE))==null) ||
                    !(table instanceof Hashtable)) {
                                   
                        throw new DataNotFoundException();
                                   
                }                                
                Hashtable members = (Hashtable)table;
                return new Boolean(members.containsKey(id));
            }
        }
                                
        
        public class ConcreteInvoker extends Invoker {
            public ConcreteInvoker(Updateable ud) throws NestingTooDeepException {
                super(ud);
            }
            public void loadRules() throws NestingTooDeepException {
                rules = new Rules();
                try {
                    //             Conditions:                              Actions:
                    //        East|West|Other|Lim|Member    
                    rules.addRule("TFFT*",                             new Action(ud,EAST_PRIVILEGED));
                    rules.addRule("TFFF*",                             new Action(ud,EAST_NOT_PRIVILEGED));
                    rules.addRule("FTFTT",                             new Action(ud,WEST_MEMBER_PRIVILEGED));
                    rules.addRule("FTFTF",                             new Action(ud,WEST_NONMEMBER_PRIVILEGED)); 
                    rules.addRule("FTFFT",                             new Action(ud,WEST_MEMBER_NOT_PRIVILEGED));
                    rules.addRule("FTFFF",                             new Action(ud,WEST_NONMEMBER_NOT_PRIVILEGED)); 
                    rules.addRule("FFT**",                             new Action(ud,OTHER_REGION));
                }
                
                catch(NestingTooDeepException e) {
                    throw e;
                }
                                        
            }
                
            public void loadConditions() throws IllegalExpressionException {
                try {  
                    conditions = new Vector(5);

                    conditions.addElement(new Condition(db.getRegion(),DataBank.EAST_REGION));
                    conditions.addElement(new Condition(db.getRegion(),DataBank.WEST_REGION));
                        
                    Hashtable other = new Hashtable();
                    other.put(OtherCondition.KEY,db.getRegion());
                    conditions.addElement(new OtherCondition(other));
                        
                    conditions.addElement(new Condition(db.LIMIT_THRESHOLD, Condition.LESS,db.getLimit() ));                         
                        
                    Hashtable mem = new Hashtable();
                    mem.put(MemberCondition.TABLE, db.getWestMembers());
                    mem.put(MemberCondition.KEY, db.getUserId());
                    conditions.addElement(new MemberCondition(mem));
                }
                catch(IllegalExpressionException e) {
                    throw e;
                }
            }
        }
        /**
         *  This main method lets you run the sample code as an application
         *  with no GUI. The output is displayed in standard output.
         */
        public static void main(String [] args) {
                DataBank db = new DataBank("0110", 5000, DataBank.Region.WEST);
                URLProcessor urlp = new URLProcessor_good();
                urlp.setDb(db);
                urlp.decideUrl();
                System.out.println("URL for this user is "+urlp.url);
        } 
                
                
}
