package logic;

import java.util.*;
public interface Updateable {
	
/**
 * 
 *  Default behavior: if the Action that calls
 *  this method is simply setting the value of
 *  an attribute, the method body for doUpdate 
 *  should look like this (for concreteness,
 *  we'll assume the attribute is a String -- you
 *  must cast the Hashtable value val to the
 *  appropriate type)
 *  <pre>
 *      Object val = vals.get(Action.MAIN_KEY);
 *      setValue((String)val);
 *  </pre>
 */      	
public void doUpdate(Hashtable vals);
}