package logic;

import java.util.*;

/**
 *  Some utilities
 */
public class Util {
	/**
	 *  Returns -1 if val is not one of the elements of intArr; otherwise
	 *  returns the index of val in intArr.
	 */
	public static int findIndex(int val, int[] intArr){
	    if(intArr == null) return -1;
	    for(int i = 0; i < intArr.length; ++i) {
	        if(val == intArr[i]) return i;
	    }
	    return -1;
	}
	
/**
 * Returns an array of Booleans having length the parameter passed in; 
 * if any element of Vector parameter
 * is not a Boolean, null is inserted into the array.
 * @author Paul Corazza
 * @return java.lang.Boolean[]
 * @param v java.util.Vector
 */
public static Boolean [] toBooleanArray(Vector v) {
	if(v == null) return null;
	Boolean [] retVal = new Boolean[v.size()];
	Object iter = null;
	for(int i = 0; i < v.size(); ++i) {
		iter = v.elementAt(i);
		retVal[i] = (iter instanceof Boolean) ? (Boolean)iter : null;
	}
	
	return retVal;
}
}